<template>
  <form @submit.prevent="$emit('submit')">
    <b-field label="Titre ">
      <b-input key="titre" v-model="groupe.nom" class="mt-input" required maxlength="25" />
    </b-field>
    <div class="columns is-mobile is-vcentered margin">
      <div class="column">
        <b-field label="Membres du groupe">
          <b-autocomplete
            class="mt-auto-complete-border-less"
            :data="autocompleteData"
            placeholder="Rechercher une personne"
            icon="magnify"
            clearable
            :loading="isFetching"
            @typing="emitTyping"
            @select="emitSelectAutocomplite"
          >
            <template #empty>aucun résultat</template>
            <template #default="{ option }">
              <article class="columns is-mobile is-vcentered">
                <div class="column is-narrow" @click="ajouter(option)">
                  <span class="is-selected" :class="isAutoCompleteSelected(option)"
                    ><b-icon icon="check-circle"></b-icon>
                  </span>
                </div>
                <div class="column" @click="ajouter(option)">
                  <mt-utilisateur :utilisateur="option"><b-icon v-if="!option.enabled" icon="lock"/></mt-utilisateur>
                </div>
              </article>
            </template>
          </b-autocomplete>
        </b-field>
      </div>
      <div class="column is-narrow">
        <mt-count-utilisateur :nombre="utilisateursSelected.length"></mt-count-utilisateur>
      </div>
    </div>
    <mt-filtre-categorie
      :fullsize="utilisateurs.fullsize"
      :categories="utilisateurs.corps"
      afficher-total
      @select-all="emitSelectAllCategorie"
      @select-categorie="emitSelectCategorie"
    >
      <mt-checkbox-all :etat="etatCheckbox" @click="selectionnerAll"></mt-checkbox-all>
    </mt-filtre-categorie>
    <mt-list v-slot="{ item: utilisateur }" :list="utilisateurs.filtrer">
      <mt-list-item :name="`utilisateur-${utilisateur.id}`" :row-class="isSelected(utilisateur)">
        <b-checkbox
          v-model="utilisateursCopie"
          :name="`b-utilisateur-${utilisateur.id}`"
          :native-value="utilisateur"
          @input="toggle(utilisateur)"
        ></b-checkbox>
        <mt-utilisateur :utilisateur="utilisateur"><b-icon v-if="!utilisateur.enabled" icon="lock"/></mt-utilisateur>
      </mt-list-item>
    </mt-list>
    <div class="field is-grouped is-grouped-centered mt-margin-top">
      <slot></slot>
    </div>
  </form>
</template>

<script>
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import MtFiltreCategorie from '~/components/filtre/filtre-categorie/index';
import MtCountUtilisateur from '~/components/pax/mt-count-utilisateur';
import userMixin from '~/components/mixins/userMixin';
import MtCheckboxAll from '~/components/base/checkbox-all';
import MtUtilisateur from '~/components/pax/mt-utilisateur';
import newCheckboxAllEtat from '~/components/mixins/checkboxAllMixin';

export default {
  name: 'MtFormGroupe',
  layout: 'container-small',
  components: {
    MtUtilisateur,
    MtCheckboxAll,
    MtCountUtilisateur,
    MtFiltreCategorie,
    MtListItem,
    MtList,
  },
  mixins: [userMixin],
  props: {
    groupe: {
      type: Object,
      default: () => ({}),
    },
    utilisateursSelected: {
      type: Array,
      default: () => [],
    },
    utilisateurs: {
      type: Object,
      default: () => ({}),
    },
    idCorps: {
      type: Number,
      default: null,
    },
    autocompleteData: {
      type: Array,
      default: () => [],
    },
    isFetching: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      all: false,
      utilisateursCopie: [],
    };
  },
  computed: {
    etatCheckbox() {
      const etat = newCheckboxAllEtat();
      if (this.utilisateursCopie.length > 0) {
        // eslint-disable-next-line no-restricted-syntax
        for (const utilisateur of this.utilisateurs.filtrer) {
          if (!this.utilisateursCopie.find((value) => value.id === utilisateur.id)) {
            etat.indeterminate = true;
            break;
          }
        }
        if (!etat.indeterminate && this.utilisateurs.filtrer.length === this.utilisateursCopie.length) {
          etat.checked = true;
        }
      }
      return etat;
    },
  },
  created() {
    this.utilisateursCopie = [...this.utilisateursSelected];
  },
  methods: {
    emitTyping(value) {
      this.$emit('typing', value);
    },
    emitSelectAutocomplite(value) {
      this.$emit('select', value);
    },
    emitSelectCategorie(value) {
      this.$emit('select-categorie', value);
    },
    emitSelectAllCategorie(value) {
      this.$emit('select-all', value);
    },
    isSelected(utilisateur) {
      if (this.find(utilisateur)) {
        return 'mt-list-item-selected';
      }
      return '';
    },
    find(utilisateur) {
      // ne pas utilisé include, ne marche pas à tous les coup.
      return this.utilisateursSelected.find((value) => value.id === utilisateur.id);
    },
    isAutoCompleteSelected(utilisateur) {
      if (this.find(utilisateur)) {
        return 'mt-list-item-selected';
      }
      return '';
    },
    selectionnerAll(value) {
      this.utilisateursCopie = [];
      if (value) {
        this.utilisateurs.filtrer.forEach((utilisateur) => {
          this.utilisateursCopie.push(utilisateur);
        });
      }
      this.$forceUpdate();
      this.$emit('selectionner-all-user', value);
    },
    ajouter(utilisateur) {
      if (!this.find(utilisateur)) {
        this.utilisateursCopie.push(utilisateur);
      }
      this.$emit('ajouter', utilisateur);
    },
    toggle(utilisateur) {
      if (this.find(utilisateur)) {
        this.$emit('delete', utilisateur);
      } else {
        this.$emit('ajouter', utilisateur);
      }
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

/deep/ .mt-list-item {
  display: flex;
  align-items: center;
}

.mt-nom-prenom {
  flex-grow: 1;
}

/deep/ .mt-filter-liste {
  & > article {
    margin-left: 0.75em;
  }
}
.margin {
  margin: 1rem 0;
}
.is-selected {
  color: #dfdfdf;

  &.mt-list-item-selected {
    color: $soft-blue;
  }
}

/deep/ .mt-list {
  max-height: 50vh;
  overflow-y: auto;
  scrollbar-width: thin;
}

/deep/ .control.has-icons-left .icon {
  color: $brown-grey;
}
</style>
